﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Timelines;
using System.Diagnostics;

namespace TimeLine_custom_proeprty
{
    public class MyDateTimeAxis :  DateTimeAxis
    {
        public DateTime MySelectedTime
        {
            get { return (DateTime)this.GetValue(MySelectedTimeProperty); }
            set
            {
                this.SetValue(MySelectedTimeProperty, value);
                Debug.WriteLine("DependencyProperty updated: " + SelectedTime.ToShortDateString());
            }
        }

        private static void AuthorNameChanged(DependencyObject d, DependencyPropertyChangedEventArgs e) 
        {
            d.SetValue(MyDateTimeAxis.MySelectedTimeProperty, e.NewValue);
            d.SetValue(MyDateTimeAxis.SelectedTimeProperty, e.NewValue);
        } 

        public static readonly DependencyProperty MySelectedTimeProperty = DependencyProperty.Register(
          "MySelectedTime", typeof(DateTime), typeof(MyDateTimeAxis), new PropertyMetadata(new DateTime(),new PropertyChangedCallback(AuthorNameChanged)));

        public MyDateTimeAxis()
            : base()
        {
        }

        protected override void OnSelectedTimeChanged(DateTimeChangedEventArgs e)
        {
            MySelectedTime = e.NewTime;
        }
    }
}
