﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;

namespace TimeLine_custom_proeprty
{
    public class ViewModel : INotifyPropertyChanged
    {
        DateTime min;
        DateTime max;
        DateTime sel;

        public DateTime MinTime
        {
            get { return min; }
            set 
            {
                min = value;
                if (PropertyChanged!=null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("MinTime"));
                }
            }
        }
        public DateTime MaxTime
        {
            get { return max; }
            set
            {
                max = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("MaxTime"));
                }
            }
        }
        public DateTime SelectedTime
        {
            get { return sel; }
            set
            {
                sel = value;
                Debug.WriteLine("ViewModel's SelectedTime property updated: " + sel.ToShortDateString());
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("SelectedTime"));
                }
            }
        }

        public ObservableCollection<TimelineData> Data { get; set; }

        public ViewModel()
        {
            MinTime = new DateTime(2012, 4, 27);
            MaxTime = new DateTime(2012, 5, 10);
            SelectedTime = new DateTime(2012, 4, 30);
            Data = new ObservableCollection<TimelineData>();
            for (int i = 1; i < 10; i++)
            {
                TimelineData dataEntry = new TimelineData()
                {
                    Time = DateTime.Today.AddDays(i),
                    Duration = new TimeSpan(8,0,0),
                    Title = "Data Title " + i,
                    Details = "Data Description " + i
                };
                Data.Add(dataEntry);
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class TimelineData
    {
        public TimelineData() { }
        public TimelineData(DateTime newTime, TimeSpan newDuration, string newTitle, string newDetails)
        {
            Time = newTime;
            Duration = newDuration;
            Title = newTitle;
            Details = newDetails;
        }
        public DateTime Time { get; set; }
        public TimeSpan Duration { get; set; }
        public string Title { get; set; }
        public string Details { get; set; }
    }

}
